Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sun.jini.phoenix
Class InstantiatorAccessExporter

    java.lang.Object
      com.sun.jini.phoenix.InstantiatorAccessExporter

All Implemented Interfaces:
  Exporter

public class InstantiatorAccessExporter
extends Object
implements Exporter

Exporter that wraps an `ActivationInstantiator` instance so that it only accepts calls from the local host.

Since:
  2.0

Constructor Summary
`InstantiatorAccessExporter()` Creates an exporter with an underlying `JrmpExporter` that exports on an anonymous port.
`InstantiatorAccessExporter(Exporter exporter)` Creates an exporter with the specified underlying exporter.

Method Summary
`Remote` | `export(Remote impl)` Wraps the specified remote object in an `ActivationInstantiator` implementation that only accepts calls from the local host before delegating to the specified remote object, exports the wrapper with the underlying exporter, and returns the resulting proxy.
`boolean` | `unexport(boolean force)` Unexports the remote object that was exported by this `Exporter` such that it will no longer receive remote method invocations that were made possible as a result of exporting it with this `Exporter`.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### InstantiatorAccessExporter

    public InstantiatorAccessExporter()

  Creates an exporter with an underlying `JrmpExporter` that exports on an anonymous port.

### InstantiatorAccessExporter

    public InstantiatorAccessExporter(Exporter exporter)

  Creates an exporter with the specified underlying exporter.

Parameters:
  `exporter` - the underlying exporter

Method Detail

### export

    public Remote export(Remote impl)
                  throws ExportException

  Wraps the specified remote object in an `ActivationInstantiator` implementation that only accepts calls from the local host before delegating to the specified remote object, exports the wrapper with the underlying exporter, and returns the resulting proxy. The wrapper is strongly referenced by this exporter. For the `newInstance` method, the wrapper throws an `AccessControlException` if the client is not calling from the local host.

  Specified by:
    `export` in interface `Exporter`
  Parameters:
    `impl` - a remote object to export
  Returns:
    a proxy for the remote object
  Throws:
    `IllegalArgumentException` - if `impl` does not implement `ActivationInstantiator`
    `NullPointerException` - if `impl` is `null`
    `IllegalStateException` - if an object has already been exported with this `Exporter` instance
    `ExportException` - if a problem occurs exporting the object

### unexport

    public boolean unexport(boolean force)

  Description copied from interface: `Exporter`
  Unexports the remote object that was exported by this `Exporter` such that it will no longer receive remote method invocations that were made possible as a result of exporting it with this `Exporter`. The unexport operation may not occur if the `force` argument is `false`. This method must only be invoked after the `export` method has been invoked on this `Exporter` instance to export a remote object successfully.

  This method returns `true` if upon return, the remote object is no longer exported with this `Exporter`, and `false` if the remote object remains exported with this `Exporter`. This method will always return `true` if it has returned `true` previously.

  The `force` parameter serves to indicate whether or not the caller desires the unexport to occur even if there are known remote calls pending or in progress to the remote object that were made possible by this `Exporter`:

  - If `force` is `true`, then the remote object will be forcibly unexported even if there are remote calls pending or in progress, and this method will return `true`.
  - If `force` is `false`, then this acts as a hint to the implementation that the remote object should not be unexported if there are known remote calls pending or in progress, and this method will either unexport the remote object and return `true` or not unexport the remote object and return `false`. If the implementation detects that there are indeed remote calls pending or in progress, then it should return `false`; otherwise, it must return `true`. If the implementation does not support being able to unexport conditionally based on knowledge of remote calls pending or in progress, then it must implement this method as if `force` were always `true`.

  If the remote object is unexported as a result of this method, then the implementation may (and should, if possible) prevent remote calls in progress from being able to communicate their results successfully.

  Specified by:
    `unexport` in interface `Exporter`
  Parameters:
    `force` - if `true`, the remote object will be unexported even if there are remote calls pending or in progress; if `false`, the remote object may only be unexported if there are no known remote calls pending or in progress
  Returns:
    `true` if the remote object is unexported when this method returns and `false` otherwise
  Throws:
    `IllegalStateException` - if an object has not been exported with this `Exporter` instance

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 Sun Microsystems, Inc. All rights reserved